/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef EARL_OMP_SYNCQUEUE_H
#define EARL_OMP_SYNCQUEUE_H

/*
 *----------------------------------------------------------------------------
 * class OMP_SyncQueue
 *---------------------------------------------------------------------------- 
 */

#include <map>

#include "Event.h"

namespace earl
{
  class Location;
  class Process;

  class OMP_SyncQueue
  {
  public:
  
    void  queue_sync(Event sync);
    Event last_sync(long lkid, Location* loc);

  private:

    // (lkid, process) |-> event (Sync_rep) 
    std::map<std::pair<long, Process*>, Event> syncm; 
  };
}
#endif




