/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "Sync_rep.h"

#include "State.h"

using namespace earl;

Sync_rep::Sync_rep(State&        state,
		   EventBuffer*  buffer,
		   Location*     loc, 
		   double        time,
		   long          lkid) :
  Event_rep(state, buffer, loc, time), 
  lkid(lkid),
  lockptr(state.last_sync(lkid, loc))
{}

bool 
Sync_rep::is_type(etype type) const
{
  if ( Event_rep::is_type(type) || type == SYNC )
    return true;
  else
    return false;
}

void 
Sync_rep::trans(State& state)
{ 
  Event_rep::trans(state);
  state.queue_sync(this); 
}




