/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _FUNCTION_H
#define _FUNCTION_H   

/*
 *----------------------------------------------------------------------------
 *
 * srtuctF Function
 *
 *----------------------------------------------------------------------------
 */

#include <iostream>
  using std::ostream;
  using std::endl;

#include <string>
  using std::string;

#include <vector>
  using std::vector;

#include <dpcl.h>

struct Callsite;
struct Module;

struct Function
{ 
  bool is_mpi();
  bool is_mpi_coll();
  bool is_omp();
       
  long               id;
  string             name;
  long               begln;
  long               endln;
  Module*            mod;
  vector<Callsite*>  csitev;
  InstPoint          entry;
  InstPoint          exit;
  bool               isuser;
  bool               isleaf;
  bool               ismpi;
  bool               ismpicoll;
  bool               isomp;
};

ostream& operator<<(ostream& out, const Function& mod); 

#endif
