/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                ** 
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         ** 
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef DLG_FUNC_H
#define DLG_FUNC_H

#include <stdio.h>

struct dlg_func;

struct dlg_func*  dlg_func_create(char* funcspec);
void              dlg_func_delete(struct dlg_func* func);

long              dlg_func_id(struct dlg_func* func);
const char*       dlg_func_name(struct dlg_func* func);
long              dlg_func_begln(struct dlg_func* func);
long              dlg_func_endln(struct dlg_func* func);
long              dlg_func_mod_id(struct dlg_func* func);
long              dlg_func_num_csites(struct dlg_func* func);
long              dlg_func_csite_id(struct dlg_func* func, long i);
const char*       dlg_func_descr(struct dlg_func* func);

long              dlg_func_get_tag(struct dlg_func* func);
void              dlg_func_set_tag(struct dlg_func* func, long tag);

void              dlg_func_fprintf(FILE* stream, struct dlg_func* func);

#endif
