/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "elg_env.h"
#include "elg_error.h"
#include "elg_pform.h"

#include <stdlib.h>
#include <string.h>

char* elg_env_gdir()
{
  char* tmp = getenv("ELG_PFORM_GDIR");

  if (tmp != NULL)
    {
      return tmp;
    }
  else
    {
      return elg_pform_gdir();
    } 
}
char* elg_env_ldir()
{
  char* tmp = getenv("ELG_PFORM_LDIR");

  if (tmp != NULL)
    {
      return tmp;
    }
  else
    {
      return elg_pform_ldir();
    } 
}

char* elg_env_fprefix()
{
  char* tmp = getenv("ELG_FILE_PREFIX");

  if (tmp != NULL)
    {
      return tmp;
    }
  else
    {
      return "a";
    } 
}

size_t elg_env_bsize()
{
  size_t buffer_size;

  char* tmp = getenv("ELG_BUFFER_SIZE");
  if (tmp != NULL)
    {
      buffer_size = atoi(tmp);
      if (buffer_size <= 0)
	  elg_error_msg("ELG_BUFFER_SIZE not properly set");
      else
	  return buffer_size;
    }
  return 10000000;
}

int elg_env_is_verbose()
{
  char* tmp = getenv("ELG_VERBOSE");
  if ((tmp != NULL) &&
      strcmp(tmp, "NO") != 0 &&
      strcmp(tmp, "no") != 0 && 
      strcmp(tmp, "No") != 0 && 
      strcmp(tmp, "0") != 0)
    {
      return 1;
    }
  else
    {
      return 0;
    }
}

int elg_env_do_merge()
{
  char* tmp = getenv("ELG_MERGE");
  if ((tmp != NULL) &&
      (strcmp(tmp, "NO") == 0 ||
       strcmp(tmp, "no") == 0 || 
       strcmp(tmp, "No") == 0 || 
       strcmp(tmp, "0") == 0))
    {
      return 0;
    }
  else
    {
      return 1;
    }
}

char*  elg_env_metrics()
{
  return getenv("ELG_METRICS");
}
