/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_METRIC_H
#define _ELG_METRIC_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

#include "elg_defs.h"

/*
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - Performance counter support
 * 
 *-----------------------------------------------------------------------------
 */

/* maximum number of events */
#define ELG_METRIC_MAXNUM 12

struct elg_metv;

EXTERN int              elg_metric_open();                           /* returns number of counters */ 
EXTERN void             elg_metric_close();
EXTERN void             elg_metric_thread_init(int (*id_fn)(void));  /* supply omp_get_thread_num() as argument */

EXTERN int              elg_metric_num();                            /* returns number of counters */ 
EXTERN double           elg_metric_clckrt();                         /* returns clock rate in Hz */ 

/* for i provide a value between 0 and elg_metric_num() - 1 */

EXTERN const char*      elg_metric_name(int i);
EXTERN const char*      elg_metric_descr(int i);
EXTERN int              elg_metric_dtype(int i);
EXTERN int              elg_metric_mode(int i);
EXTERN int              elg_metric_iv(int i);

/* create and free per-thread counter sets */

EXTERN struct elg_metv* elg_metric_create();
EXTERN void             elg_metric_free(struct elg_metv* metv);

/* reads values of counters relative to the time of elg_metric_open() */
EXTERN void             elg_metric_read(struct elg_metv* metv, elg_ui8 values[]);

#endif









