/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_MPICOM_H
#define _ELG_MPICOM_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

#include "mpi.h"

/* 
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - MPI communicator management
 *
 *-----------------------------------------------------------------------------
 */

EXTERN void    elg_comm_init();
EXTERN void    elg_comm_finalize();

EXTERN void    elg_comm_create(MPI_Comm comm);
EXTERN void    elg_comm_free(MPI_Comm comm);

EXTERN elg_ui4 elg_comm_id(MPI_Comm comm);

EXTERN int     elg_rank_to_pe(int rank, MPI_Comm comm);

/* MPI communicator |-> EPILOG communicator id */
#define ELG_COMM_ID(c) (((c)==MPI_COMM_WORLD) ? 0 : elg_comm_id(c))

/* Rank with respect to arbitrary communicator |-> global rank */
#define ELG_RANK_TO_PE(r,c) (((c)==MPI_COMM_WORLD) ? r : elg_rank_to_pe(r,c))

#endif









