/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdio.h>
#include "elg_pform.h"

int main() {
  double t1, t2;
  int i;

  elg_pform_init();
  printf("platform            : %s\n", elg_pform_name());
  printf("number or CPUs      : %d x %d\n", elg_pform_num_nodes(), elg_pform_num_cpus());
  printf("node id             : %d\n", elg_pform_node_id());
  printf("node name           : %s\n", elg_pform_node_name());
  printf("global directory    : %s\n", elg_pform_gdir());
  printf("node local directory: %s\n", elg_pform_ldir());
  printf("global clock        : %d\n", elg_pform_is_gclock());
  printf("current time        : %16.9f\n", elg_pform_wtime());
  sleep(3);
  printf("current time        : %16.9f\n", elg_pform_wtime());
  t1 = elg_pform_wtime();
  for (i=0; i<1000; i++) t2 = elg_pform_wtime();
  printf("per call            : %16.9f\n", (t2 - t1) / 1000.0);
  return 0;
}
