/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_USER_H
#define _ELG_USER_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

/*
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - User Instrumentation
 * 
 *-----------------------------------------------------------------------------
 */

#ifdef EPILOG
  EXTERN void elg_user_start(char* name, char *file, int lno);
  EXTERN void elg_user_end(char *name);

  #ifdef __cplusplus
    class elg_tracer {
    public:
      elg_tracer(char* name, char *file, int lno) : n(name) {
        elg_user_start(name, file, lno);
      }
      ~elg_tracer() { elg_user_end(n); }
    private:
      char *n;
    };
    #define ELG_TRACER(n) elg_tracer elg_trc__(n, __FILE__, __LINE__)
  #endif

  #define ELG_USER_START(n) elg_user_start(n, __FILE__, __LINE__)
  #define ELG_USER_END(n)   elg_user_end(n)
#else
  #define ELG_USER_START(n)
  #define ELG_USER_END(n)
  #define ELG_TRACER(n)
#endif

#endif
