!****************************************************************************
!*  KOJAK                                                                  **
!*  http://www.fz-juelich.de/zam/kojak/                                    **
!****************************************************************************
!*  Copyright (C) 1998-2004                                                **
!*  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
!*                                                                         **
!*  See the file COPYRIGHT in the package base directory for details       **
!***************************************************************************/

subroutine step(id, tid, i)
  integer :: id, tid, i

  write (*,*) id, ":", tid, ": step", i
end subroutine

subroutine sequential(id)
  integer :: i, tid=0
  integer :: omp_get_thread_num

  !$OMP PARALLEL PRIVATE(tid)
#ifdef OPENMP
    tid = omp_get_thread_num()
#endif
    !$OMP DO
    do i=1,12
      call step(id, tid, i)
    enddo
    !$OMP END DO
  !$OMP END PARALLEL
end subroutine

program main
  include 'mpif.h'
  integer :: id=0, numprocs, value=42, ierr
  
  call MPI_Init(ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, numprocs, ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, id, ierr)
  call MPI_Bcast(value, 1, MPI_INTEGER, numprocs-1, MPI_COMM_WORLD, ierr)

  call sequential(id)

  call MPI_Barrier(MPI_COMM_WORLD, ierr)
  call MPI_Finalize(ierr)
end program main
