
class Severity:

    def __init__(self, nrlocs):

        self._nrlocs  = nrlocs
        
        # initialize matrix
        # !!!!! caveat: order of indices in self._matrix (loc_id, cnode_id) is
        # different from order of indices in methods (cnode_id, loc_id) 
        self._matrix = []
        for l in range(self._nrlocs):
            self._matrix.append({})

    def add(self, cnode_id, loc_id, value):
        self._matrix[loc_id][cnode_id] = self.get(cnode_id, loc_id) + value

    def sub(self, cnode_id, loc_id, value):
        self._matrix[loc_id][cnode_id] = self.get(cnode_id, loc_id) - value

    def set(self, cnode_id, loc_id, value):
        self._matrix[loc_id][cnode_id] = value

    def get(self, cnode_id = None, loc_id = None):

        result = 0

        # sum across the entire matrix
        if cnode_id == None:
            for loc_id in range(self._nrlocs):
                for cnode_id in self._matrix[loc_id].keys():
                    result += self.get(cnode_id)

        # sum across all locations            
        elif loc_id == None:
            for loc_id in range(self._nrlocs):
                result += self.get(cnode_id, loc_id) 

        # individual elements        
        else:
            if not cnode_id in self._matrix[loc_id].keys():
                result = 0
            else:
                result = self._matrix[loc_id][cnode_id]

        return result        
        
    def exclusify(self, ctree, cnode_id = None):
        if cnode_id == None:
            for root_id in ctree.roots():
                self.exclusify(ctree, root_id)
        else:
            for child_id in ctree.children(cnode_id):
                for loc_id in range(self._nrlocs):
                    self.sub(cnode_id, loc_id, self.get(child_id, loc_id))
                self.exclusify(ctree, child_id)

    def inclusify(self, ctree):
        if cnode_id == None:
            for root_id in ctree.roots():
                self.exclusify(ctree, root_id)
        else:
            for child_id in ctree.children(cnode_id):
                self.inclusify(ctree, child_id)
                for loc_id in range(self._nrlocs):
                    self.add(cnode_id, loc_id, self.get(child_id, loc_id))
        










