#!/usr/bin/python

# automatically add <expert-home>/lib to module search path
import sys
mypath = sys.path[0]
if mypath[-3:] == "pyc":
    sys.path.append(mypath[:-3]+"lib")
    sys.path.append(mypath[:-3]+"lib32")
elif mypath == "." or mypath == "":
    sys.path.append("../lib")
    sys.path.append("../lib32")

import profile
import time

from earl import *
from Analyzer import *

def main():
                
    if len(sys.argv) != 2:
        print "Error: Wrong number of arguments."
    else:
        start = time.time()

        # open trace file
        trace = EventTrace(sys.argv[1])
        print 'Total number of events:', trace.get_nevents()

        # start analysis
        analyzer = Analyzer(trace)
        analyzer.run()

        # calculate time needed by analysis
        end = time.time()
        seconds = int(round(end - start,0))
        print 'Elapsed time (h:m:s): ', seconds / 3600, ':', (seconds % 3600) / 60, ':', (seconds % 60)

        # calculate event rate
        if seconds == 0:
            seconds = 1
        print 'Events per second: ', trace.get_nevents() / seconds
        
if __name__ == '__main__':
    # profile.Profile.bias = 1.20e-05
    # profile.run("main()", "new_analyzer.prof")
    main()

